 // Product
 interface Product {
	 public void foo(); 
 }
 
 // ConcreteProductA
 class ConcreteProductA implements Product {
	 public void foo() {
		 System.out.println("A");
	 }
 }
 
 // ConcreteProductB
 class ConcreteProductB implements Product {
	 public void foo() {
		 System.out.println("B");
	 }
	 public static Creator creator = new Creator() {
		public Product getProduct() {
			return new ConcreteProductB();
		}
	 };
 }
 
 
 // Creator
 abstract class Creator {
     public abstract Product getProduct();
 }
 
 // ConcreteCreatorA
 class ConcreteCreatorA extends Creator {
     public Product getProduct() {
         return new ConcreteProductA();
     }
 }
 
public class FabricMethod {
	public static void doSmth(Creator cr) {
		cr.getProduct().foo();
	}
	public static void main(String[] args) {
		doSmth(new ConcreteCreatorA());
		doSmth(ConcreteProductB.creator);
	}
 
}