interface Event {
	public void run();
}
 
class EventTest {
	private Event[] events;
	public EventTest() {
		events = new Event[10];
		for (int i = 0; i < 10; i++) {
			events[i] = new Event() {
				private int i = 10;
				public void run() {
					System.out.println("It's me! " + i);
				}
			};
		}
	}
	public void run() {
		for (int i = 0; i < 10; i++) {
			events[i].run();
		}
	}	
}